#----------------------------------------------------------------------------
#
#   MatSheet - Operations for undo/redo
#
#----------------------------------------------------------------------------
#
#   Classes here represent editing operations on the sheet
#   and are stored in the sheet's undo and redo stacks.
#
#   Each operation class has a do() method that performs
#   the operation and returns another operation object
#   representing the inverse operation.
#

class SheetOp(object):
    pass

class ChangeCell(SheetOp):

    def __init__(self, bc, value):
        self.bc = bc
        self.value = value
    
    def do(self, sheet):
        bc = self.bc
        old_value = sheet.get_cell_value(bc)
        sheet.set_cell_value(bc, self.value)
        return ChangeCell(bc, old_value)
